<control-ad-textarea>

	<textarea class="form-control" id="paper_text" data-ref="text" rows="6" onkeyup="{ input_change }">{ state.value }</textarea>
	<div class="paper-text-words">Λέξεις αγγελίας: { state.words } / { state.word_limit }</div>

	<script>
	/*
		Methods:
		set_value( new_value ) :: set the value of the textarea control
		get_value() :: return the value of the textarea control
		set_word_limit( new_limit ) :: set the maximum word limit
		validate() :: returns true if text words <= word_limit

		Opts:
		wordlimit :: set the maximum word limit
		onchangehandler() :: trigger when textarea control is changed
	*/

		this.state = {
			word_limit: this.opts.wordlimit ? this.opts.wordlimit : 0,
			words: 0,
			//value: this.opts.value ? this.opts.value : "",
		}

		this.input_change = event => {
 			this.check_words(event);
 			this.opts.onchangehandler();
		}


		this.check_words = event => {
			this.state.words = this.count_words(this.refs.text.value);
 			if (this.state.words > this.state.word_limit) {
 				$('#paper_text').addClass('alert-danger');
 			} else {
 				$('#paper_text').removeClass('alert-danger');
 			}

 			if (typeof event === 'undefined') {
 				this.update();
 			}
		}


		this.count_words = (str) => {
			var resultArray = [];
			str = str.replace(/[\t\n\r\.\;\,\?\!]/gm,' ');

			var wordArray = str.split(" ");
			for (var i = 0; i < wordArray.length; i++) {
				var item = wordArray[i].trim();
				if (item.length > 2) {
					resultArray.push(item);
				}
			}
			return resultArray.length;
		}


		this.set_word_limit = word_limit => {
			if (!word_limit || typeof word_limit === 'undefined') {
				word_limit = 25;
			}
			this.state.word_limit = word_limit;
			this.check_words();
		}


		this.set_value = value => {
			this.refs.text.value = value;
			this.check_words();
		}


		this.get_value = () => {
			return this.refs.text.value;
		}


		this.validate = () => {
			return this.state.words <= this.state.word_limit;
		}


		this.on('mount', this.check_words);
	</script>
</control-ad-textarea>